// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from zbar_ros_interfaces:msg/Symbol.idl
// generated code does not contain a copyright notice
#include "zbar_ros_interfaces/msg/detail/symbol__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `data`
#include "rosidl_runtime_c/string_functions.h"
// Member `points`
#include "vision_msgs/msg/detail/point2_d__functions.h"

bool
zbar_ros_interfaces__msg__Symbol__init(zbar_ros_interfaces__msg__Symbol * msg)
{
  if (!msg) {
    return false;
  }
  // data
  if (!rosidl_runtime_c__String__init(&msg->data)) {
    zbar_ros_interfaces__msg__Symbol__fini(msg);
    return false;
  }
  // points
  if (!vision_msgs__msg__Point2D__Sequence__init(&msg->points, 0)) {
    zbar_ros_interfaces__msg__Symbol__fini(msg);
    return false;
  }
  return true;
}

void
zbar_ros_interfaces__msg__Symbol__fini(zbar_ros_interfaces__msg__Symbol * msg)
{
  if (!msg) {
    return;
  }
  // data
  rosidl_runtime_c__String__fini(&msg->data);
  // points
  vision_msgs__msg__Point2D__Sequence__fini(&msg->points);
}

bool
zbar_ros_interfaces__msg__Symbol__are_equal(const zbar_ros_interfaces__msg__Symbol * lhs, const zbar_ros_interfaces__msg__Symbol * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // data
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  // points
  if (!vision_msgs__msg__Point2D__Sequence__are_equal(
      &(lhs->points), &(rhs->points)))
  {
    return false;
  }
  return true;
}

bool
zbar_ros_interfaces__msg__Symbol__copy(
  const zbar_ros_interfaces__msg__Symbol * input,
  zbar_ros_interfaces__msg__Symbol * output)
{
  if (!input || !output) {
    return false;
  }
  // data
  if (!rosidl_runtime_c__String__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  // points
  if (!vision_msgs__msg__Point2D__Sequence__copy(
      &(input->points), &(output->points)))
  {
    return false;
  }
  return true;
}

zbar_ros_interfaces__msg__Symbol *
zbar_ros_interfaces__msg__Symbol__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  zbar_ros_interfaces__msg__Symbol * msg = (zbar_ros_interfaces__msg__Symbol *)allocator.allocate(sizeof(zbar_ros_interfaces__msg__Symbol), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(zbar_ros_interfaces__msg__Symbol));
  bool success = zbar_ros_interfaces__msg__Symbol__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
zbar_ros_interfaces__msg__Symbol__destroy(zbar_ros_interfaces__msg__Symbol * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    zbar_ros_interfaces__msg__Symbol__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
zbar_ros_interfaces__msg__Symbol__Sequence__init(zbar_ros_interfaces__msg__Symbol__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  zbar_ros_interfaces__msg__Symbol * data = NULL;

  if (size) {
    data = (zbar_ros_interfaces__msg__Symbol *)allocator.zero_allocate(size, sizeof(zbar_ros_interfaces__msg__Symbol), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = zbar_ros_interfaces__msg__Symbol__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        zbar_ros_interfaces__msg__Symbol__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
zbar_ros_interfaces__msg__Symbol__Sequence__fini(zbar_ros_interfaces__msg__Symbol__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      zbar_ros_interfaces__msg__Symbol__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

zbar_ros_interfaces__msg__Symbol__Sequence *
zbar_ros_interfaces__msg__Symbol__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  zbar_ros_interfaces__msg__Symbol__Sequence * array = (zbar_ros_interfaces__msg__Symbol__Sequence *)allocator.allocate(sizeof(zbar_ros_interfaces__msg__Symbol__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = zbar_ros_interfaces__msg__Symbol__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
zbar_ros_interfaces__msg__Symbol__Sequence__destroy(zbar_ros_interfaces__msg__Symbol__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    zbar_ros_interfaces__msg__Symbol__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
zbar_ros_interfaces__msg__Symbol__Sequence__are_equal(const zbar_ros_interfaces__msg__Symbol__Sequence * lhs, const zbar_ros_interfaces__msg__Symbol__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!zbar_ros_interfaces__msg__Symbol__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
zbar_ros_interfaces__msg__Symbol__Sequence__copy(
  const zbar_ros_interfaces__msg__Symbol__Sequence * input,
  zbar_ros_interfaces__msg__Symbol__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(zbar_ros_interfaces__msg__Symbol);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    zbar_ros_interfaces__msg__Symbol * data =
      (zbar_ros_interfaces__msg__Symbol *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!zbar_ros_interfaces__msg__Symbol__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          zbar_ros_interfaces__msg__Symbol__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!zbar_ros_interfaces__msg__Symbol__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
